package rhu_Ignore;

use strict;

# -----------------------------------------------------------------------------

sub new() {

  my $class = shift @_;
  my $args  = shift;
  my $rhu   = shift;
  
    my $self = { };

    bless($self, $class);

    $self->{CLASS} = $class;
    $self->{RHU}   = $rhu;
    $self->{ARGS}  = $args;

    $self->{RPMS} = &get_list_of_RPMs_to_ignore();

    # -- log what's to be ignored :

    $self->{RHU}->log("v", 0, "simple", [""]);
    $self->{RHU}->log("v", 0, "simple", ["Ignoring:  "]);
    foreach (@{$self->rpms()}) {
        $self->{RHU}->log("v", 1, "simple", ["$_"]);
      }

    return $self;
  }


# -----------------------------------------------------------------------------
# -- This should obviously come from somewhere more sensible than this-here
#    list in the near future...

sub get_list_of_RPMs_to_ignore() {

    my $list = { };

    $list->{"vim-minimal"}  = "1";
    $list->{"vim-enhanced"} = "1"; 
    $list->{"vim-common"}   = "1"; 
    $list->{"vim-X11"}      = "1"; 
 
    return $list;
  }


# -----------------------------------------------------------------------------

sub ignored() {

  my $self = shift;
  my $rpm  = shift;

    if (defined $self->{RPMS}->{$rpm}) {
        return 1;
      }
    else {
        return 0;
      }
  }

# -----------------------------------------------------------------------------

sub rpms() {

  my $self = shift;

    my @keys = keys %{$self->{RPMS}};
    return \@keys;
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
