package rhu_RPMs_Updates_Local;

use vars qw(@ISA);
@ISA = ("rhu_RPMs_Template");

use strict;

# -----------------------------------------------------------------------------
# -- CONSTRUCT :
# -----------------------------------------------------------------------------

# --

sub new() {

  my $class = shift;
  my $args  = shift;
  my $rhu   = shift;

    my $self = { };

    bless($self, $class);

    $self->{CLASS} = $class;
    $self->{ARGS}  = $args;
    $self->{RHU}   = $rhu;

    ($self->{FILES}, $self->{NAMES}, $self->{VERS}, $self->{RELS}) 
                             = $self->get_list_of_already_downloaded_updates();

    $self->{RHU}->log("vv", 1, "simple", ["Already-downloaded updates are :"]);
    foreach (sort keys %{$self->{FILES}}) {
        $self->{RHU}->log("vv", 2, "simple", [$self->{FILES}->{$_}]);
      }   

    return $self;
  }

# -----------------------------------------------------------------------------
# -- CONSTRUCTOR SLAVES :
# -----------------------------------------------------------------------------

# --

sub get_list_of_already_downloaded_updates() {

    my $self  = shift;
    my $files = { };

    my ($files, $names, $versions, $releases);

    opendir(DIR, $self->{RHU}->rootdir()) 
        || die "\n\n Can't open local-updates " 
             . "directory :  " . $self->{RHU}->rootdir() . "\n\n";

    while (my $file = readdir(DIR)) {
        if (($file eq ".") || ($file eq "..")) {next;}

        my $tmp = $file;
        $tmp    =~ s/\.i386\.rpm$//;
        my @tmp = split(/\-/, $tmp);

        my $release = $tmp[$#tmp];
        my $version = $tmp[$#tmp - 1];

        my $name = $file;
        $name =~ s/\-$version\-$release\.i386\.rpm$//;

        $files->{$file} = $file;

        $names->{$name}    = $name;
        $versions->{$name} = $version;
        $releases->{$name} = $release;
      }

    close(DIR);

    return ($files, $names, $versions, $releases);
  }

# -----------------------------------------------------------------------------
# -- PUBLIC READ METHODS :
# -----------------------------------------------------------------------------

# --

sub exists_name() {
    my $self      = shift;
    my $rpm_name  = shift;

###    print "\n exists_name: $rpm_name";

    if (defined $self->{NAMES}->{$rpm_name}) {
        return 1;
      }
    else {
        return 0;
      }
  }


# --

sub exists_file() {
    my $self = shift;
    my $file = shift;

    if (defined $self->{FILES}->{$file}) {
        return 1;
      }
    else {
        return 0;
      }
  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
